from ophyd import Device, EpicsMotor, EpicsSignal, EpicsSignalRO
from ophyd import Component as Cpt

#option I via direct acces to classes

ScanX = EpicsMotor(name='ScanX',prefix='X07MB-ES-MA1:ScanX')
ScanY = EpicsMotor(name='ScanY',prefix='X07MB-ES-MA1:ScanY')
DIODE = EpicsSignal(name='SI',read_pv='X07MB-OP2-SAI_07:MEAN')
SMPL   = EpicsSignal(name='SMPL',read_pv='X07MB-OP2:SMPL')
CYCLES = EpicsSignal(name='SMPL',read_pv='X07MB-OP2:TOTAL-CYCLES',write_pv='X07MB-OP2:TOTAL-CYCLES')


prefix='XXXX:'
y_cpt = Cpt(EpicsMotor, 'ScanX')
# Option 2 using component
prefix='X07MB-ES-MA1:'
dd=Device('X07MB-ES-MA1:',name=('device'))
y_cpt_prefix = Cpt(EpicsMotor,'ScanX',parent=Device)

class StageXY(Device):

    x = Cpt(EpicsMotor, 'ScanX')
    y = Cpt(EpicsMotor, 'ScanY')

xy_stage = StageXY('X07MB-ES-MA1:', name='stage')

#############################################
# This is basic bluesky
# Epics motor def seems to use init params in device, whcih are
# __init__(
#        self,
#        prefix="",
#        *,
#        name,
#        kind=None,
#        read_attrs=None,
#        configuration_attrs=None,
#        parent=None,
#        **kwargs,
#    ):
#
#########################################################

print(xy_stage.x.prefix)
xy_stage.__dict__


# to move motor use
# stage.x.move(0)
# to see all dict
# stage.x.__dict__
